c assignment 1 csc2307
c  The following include file defines the bit numbers for the 
c  possible floating point exceptions.

#include <f77/f77_floatingpoint.h>
c  Need to define progam variables before declaring the 
c  statement functions.
c

      integer ieeer, ieee_flags
      character*16 out
*                                  floating point exception variables
       REAL poly(4)               
*                                  poly holds polynomial coefficients
       COMPLEX p(4)
*                                  p holds complex version of roots
       real rr(3), ri(3)
*                                  rr holds real portion of roots
*                                  and ri holds imaginary portion
       INTEGER iflag(4)
*                                  flags floating point exceptions
       INTEGER id
*                                  line number in data file, -1 signals EOF

c
c

c     Make sure that the floating point status flags are zero
c     before we start computing.

      ieeer = ieee_flags( 'clear', 'exception', 'all', out )



 1     READ *, id,poly(1),poly(2),poly(3),poly(4)
c                        read data line from input file
c                        data line consists of nonzero idnumber followed
c                        by four real coefficents, all separated by commas

       do j=1,3
          IFLAG(j) = 1
c                        assign all flags to "no problem"    
       enddo
       PRINT *,'read line from data file'
       if (id .lt. 0) then
          stop
       endif
       ieeer = ieee_flags( 'get', 'exception', 'all', out )
c                       check for not a number exceptions
       PRINT *, 'got exceptions'
       if (ieer) then
           IFLAG(1) = -2        
           IFLAG(2) = -2
           IFLAG(3) = -2
c                       one of the coefficients is not a number
c                       so all flags set to -2
       end if
       do j=1, 4
          p(j) = CMPLX(poly(j)) 
c                       array of equivalent complex coefficients
c                       for use in laguer
       enddo          
       PRINT *, 'assigned coefficient array'
       CALL cubic(p,rr,ri,iflag)
       PRINT *,'returned from cubic'
       go to 1
       END

       SUBROUTINE cubic (A, RR, RI, IFLAG)
       COMPLEX A(4)
       REAL RR(3)
       REAL RI(3)
       COMPLEX R(3)
       INTEGER IFLAG(3)
       COMPLEX rt
c      figure out degenerate cases
c      case 1. a1=0, a2=0, a3=0 a4=0
c              cubic has infinitely many roots
       PRINT *, 'checking condition 1'
       if ((real(A(1))).eq. 0.) then
           PRINT *, 'coeff 1 is zero'
           if ((real(A(2))).eq. 0.) then
              PRINT *, 'coeff 2 is zero'
              if  ((real(A(3))).eq. 0.) then
                 if ((real(A(4))).eq. 0.) then
                        PRINT *, 'infinite roots'
                        IFLAG(1) = 0
                        IFLAG(2) = 0
                        IFLAG(3) = 0
                        PRINT *, 'iflag assigned to zero'
                 endif
              endif
           endif
c              return with all IFLAG set to 0 and arbitrary RR and RI
c      case 2. a1=a2=a3=0 and a0 != 0
       else if (real(A(1)) .eq. 0.) then
             if (real(A(2)) .eq. 0.) then
               if (real(A(3)) .eq. 0.) then
                  if (real(A(4)) .ne. (0.)) then
                       IFLAG(1) = -1
                       IFLAG(2) = -1
                       IFLAG(3) = -1
                  endif
               endif
             endif
c              cubic has no roots
c              return with all IFLAG set to -1 with arbitrary RR and RI
       else   
             PRINT *, 'calling zroots.'
             CALL zroots(A,3,R,.true., IFLAG)
             do j=1,3
c                rt = R(j)
c                RR(j) = real(rt)
                RI(j) = rt - cmplx(real(rt))
                PRINT *,'root ', j, ' cmpl ', R(j)
                PRINT *, 'okay...'
             enddo
             PRINT *, 'done the do'
       endif   
       PRINT *, 'IFLAG'
       do j=1,3
          PRINT *, j, ": ", IFLAG(j)
c                          print out exception flags
       enddo  
       PRINT *, 'clearing exceptions'
       ieeer = 0
c                          reset ieeer flag (prevents seg fault)          
       ieeer = ieee_flags( 'clear', 'exception', 'all', out )
c                          clear all exceptions
       PRINT *, 'cleared exceptions, returning to main'
       RETURN 
       END
          
       


       SUBROUTINE laguer(a,m,x,its)
       INTEGER m, its, MAXIT, MR, MT
       REAL EPSS
       COMPLEX a(m+1), x
c      given degree m of polynomial, and an array of the complex coefficients
c      of the polynomial, a, and given a complex value x as a starting guess,
c      laguer improves x by Laguerre's method until it converges within 
c      reasonable roundoff limit to a root of the given polynomial. The number
c      of iterations taken is returned as its.
c      EPSS is the estimated fractional roundoff error. rare limit cycles are
c      broken with MR different fractional values, for MAXIT total allowed
c      iterations
       PARAMETER (EPSS=2.e-7, MR=8,MT=10,MAXIT=MT*MR*10)
       INTEGER iter,j
       REAL abx, abp, abm, err, frac(MR)
       COMPLEX dx,x1,b,d,f,g,h,sq,gp,gm,g2
       SAVE frac
       DATA frac /.5,.25,.75,.13,.38,.62,.88,1./
c      fractions used to break limit cycle
       do   iter=1, MAXIT
c      loop over iterations up to allowed maximum
            its = iter
            b=a(m+1)
            err=abs(b)
            d=cmplx(0.,0.)
            f=cmplx(0.,0.)
            abx=abs(x)
            do  j=m, 1, -1
c           computation of polynomial and its first 2 derivatives
                f=x*f+d
                d=x*d+b
                b=x*b+a(j)
                err=abs(b)+abx*err
            enddo
            err=EPSS*err
c           estimated roundoff error in evaluating polynomial
            if(abs(b) .le. err) then 
c           root is found
                 return
            else
c           use Laguerre's formula
                 g=d/b
                 g2=g*g
                 h=g2-2.*f/b
                 sq=sqrt((m-1)*(m*h-g2))
                 gp=g+sq
                 gm=g-sq
                 abp=abs(gp)
                 abm=abs(gm)
                 if(abp .lt. abm) gp=gm
                 if (max(abp,abm) .gt. 0.) then
                     dx=m/gp
                 else 
                     dx=exp(cmplx(log(1.+abx),float(iter)))
                 endif
            endif
            x1=x-dx
            if (x .eq. x1) return
c           converged to root
            if (mod(iter,MT) .ne. 0) then
                x=x1
            else
                x=x-dx*frac(iter/MT)
c           fractional step to break limit cycles
            endif
       enddo
       pause 'too many iterations in laguer'
       return
       END

       SUBROUTINE zroots(a,m,roots,polish, IFLAG)
       INTEGER m,MAXM
       REAL EPS
       INTEGER IFLAG(3)
       COMPLEX a(m+1),roots(m)
       LOGICAL polish
       PARAMETER (EPS=1.e-6,MAXM=101)
c      uses laguer .. given the degree m and the complex coefficients of the 
c      polynomial in a(1:m+1), this routine successively calls laguer to find
c      all m complex roots. polish is a boolean parameter that when set to
c      .true. uses laguer for root polishing. IFLAG is the array of exceptions
c      that keeps track of which exceptions occurred
       INTEGER i,j,jj,its
       COMPLEX ad(MAXM),x,b,c
c      copy of coefficients for successive deflation
       do j=1,m+1
          ad(j)=a(j)
       enddo
       do j=m,1,-1
c      loop over each root to be found starting at zero to favor convergence 
c      to smallest possible root
          x=cmplx(0.,0.)
          call laguer(ad,j,x,its)
c      find the root
          if((abs(aimag(x))) .le. (2.*EPS**2*abs(real(x)))) then
                  x=cmplx(real(x),0.)
          endif
          roots(j) = x
c  Check the exception flags.
c
          ieeer = ieee_flags( 'get', 'exception', 'all', out )
          if (( out .eq. 'underflow') .or. ( out .eq. 'overflow' )) then
                     IFLAG(j) = -3
          else if ( out .eq. 'invalid' ) then
                     IFLAG(j) = -6
          else if ( out .eq. 'inexact' ) then
                     IFLAG(j) = -5
          else 
              IFLAG(j) = 1
          end if
          b = ad(j+1)
c         forward deflation
          do jj=j,1,-1
              c=ad(jj)
              ad(jj)=b
              b=x*b+c
          enddo
       enddo 
       if (polish) then
c      polish the roots using the undeflated coefficients
           do j=1,m
          x=cmplx(0.,0.)
              call laguer(a,m,roots(j),its)
           enddo
       endif
       do j=2,m
c      sort roots by their real parts by straight insertion
          x=roots(j)
          do i=j-1,1,-1
             if(real(roots(i)) .le. real(x)) goto 30
             roots(i+1)=roots(i)
          enddo
          i=0
 30       roots(i+1) = x
       enddo
       RETURN
       END





