c Floating point constants in single and double precision.
c          largest number: flmax, dflmax
c          smallest positive normalized number: flmin, dflmin
c          machine epsilon:  eps, deps
c flmax, dflmax, flmin, dflmin are Sun system supplied functions;
c eps and deps computed according to the algorithm on p. 23 of Miller's
c book "The Engineering of Numerical Software" are supplied below.  
c Usually all six functions are supplied in a UNIX environment.
c
c K.R.J.  12/10/88.

	real flmax, flmin, eps
	double precision dflmax, dflmin, deps
	print *, flmin(), flmax(), eps(), 2.e0**(-23)
	print *, dflmin(), dflmax(), deps(), 2.d0**(-52)
	stop
	end

	real function eps()
	real epss, epss1, try, try1, identr
	logical first
	save epss, first
	data first /.true./

	if ( first ) then
	   first = .false.
	   try = 1.e0
 10	   continue
	      epss = try
	      try = .5e0 * epss
	      try1 = try + 1.e0
	      if ( identr(try1) .gt. 1.e0 ) go to 10
c	   end loop
	   epss1 = epss + 1.e0
	   epss = epss1 - 1.e0
	endif

	eps = epss

	return
	end

	real function identr(x)
	real x
	identr = x
	return
	end

	double precision function deps()
	double precision epss, epss1, try, try1, identd
	logical first
	save epss, first
	data first /.true./

	if ( first ) then
	   first = .false.
	   try = 1.e0
 10	   continue
	      epss = try
	      try = .5e0 * epss
	      try1 = try + 1.e0
	      if ( identd(try1) .gt. 1.e0 ) go to 10
c	   end loop
	   epss1 = epss + 1.e0
	   epss = epss1 - 1.e0
	endif

	deps = epss

	return
	end

	double precision function identd(x)
	double precision x
	identd = x
	return
	end
