	program spec

	open(1, file='test')
	open(2, file='results')
	open(3, file='failures')

	call comp(1, 2, 3)
	close(1)
	close(2)
	close(3)

	stop
	end



	subroutine comp(in, res, prob)
	integer in, res, prob

	real t0, t1, t2, t3
	real it0, it1, it2, it3
	complex a0, a1, a2, a3
	complex abs0, abs1, abs2, abs3
	complex ap0, ap1, ap2, ap3
	complex a, ap
	real meps
	complex rmin, rmax
	complex max
	integer fail(0:3)
	logical ex
	real Mag

	parameter (meps=2.**-23)

50	format(4e16.8)
51	format(4e16.8)

55	read(res, *, end=205), flag

	read(in, 50), t3, t2, t1, t0

	a0=cmplx(t0, 0)
	a1=cmplx(t1, 0)
	a2=cmplx(t2, 0)
	a3=cmplx(t3, 0)

	if (flag .ne. 0) then
	  read(res, 50), t3, t2, t1, t0, it3, it2, it1, it0

	  ap0=cmplx(t0, it0)
	  ap1=cmplx(t1, it1)
	  ap2=cmplx(t2, it2)
	  ap3=cmplx(t3, it3)

	  if (real(a3) .ne. 1.) then
	    ap0=ap0*a3
	    ap1=ap1*a3
	    ap2=ap2*a3
	    ap3=ap3*a3
	  endif

	  abs0=abs(a0)
	  abs1=abs(a1)
	  abs2=abs(a2)
	  abs3=abs(a3)

	  if(Mag(abs1) .gt. Mag(abs2)) then
	    if(Mag(abs1) .gt. Mag(abs3)) then
	      ap=abs1
	    else
	      ap=abs3
	    endif
	 
	    if(Mag(abs1) .gt. Mag(abs0)) then
	      a=abs1
	    else
	      a=abs0
	    endif

	  else
	    if(Mag(abs2) .gt. Mag(abs3)) then
	      ap=abs2
	    else
	      ap=abs3
	    endif

	    if(Mag(abs2) .gt. Mag(abs0)) then
	      a=abs2
	    else
	      a=abs0
	    endif
	  endif  

	  if(Mag(abs0/(ap+abs0)) .lt. Mag(1+a/abs3)) then
	    rmin=abs0/(ap+abs0)
	    rmax=1+a/abs3
	  else
	    rmax=abs0/(ap+abs0)
	    rmin=1+a/abs3
	  endif

	  fail(0) = 0
	  fail(1) = 0
	  fail(2) = 0
	  fail(3) = 0

	  if(ap3 .ne. a3) fail(3)=1

	  if(Mag(a0-ap0) .gt. (100.*meps)*Mag(abs0))  then
	    fail(0)=1
*	    print 50, Mag(a0-ap0), meps2, 100.*meps2, Mag(abs0)
	  endif

	  if (Mag(abs0) .gt. Mag(abs1*rmin)) then
	    max=abs0/rmin
	  else
	    max=abs1
	  endif

	  if(Mag(a1-ap1) .gt. (100.*meps)*Mag(max))  fail(1)=1

	  if (Mag(abs3*rmax) .gt. Mag(abs2)) then
	    max=abs3*rmax
	  else
	    max=abs2
	  endif

	  if(Mag(a2-ap2) .gt. (100.*meps)*Mag(max))  fail(2)=1

	  ex=.false.
	  if(fail(0)+fail(1)+fail(2)+fail(3) .ge. 1) ex=.true.

	  if(fail(0)+fail(1)+fail(2) .eq. 1) then

	    if(fail(0) .eq. 1) then
	      if(Mag((a0-ap0)/abs0) .lt. 100.) ex=.false.

	    elseif(fail(1) .eq. 1) then
	      if(Mag((a1-ap1)/abs1) .lt. 100.) ex=.false.

	    elseif(fail(2) .eq. 1) then
	      if(Mag((a2-ap2)/abs2) .lt. 100.) ex=.false.
	    endif

	  endif

	  if (ex) then
*	    write(prob, *), fail(3), fail(2), fail(1), fail(0)
*	    write(prob, 51), real(a3), real(a2), real(a1), real(a0)
*	    write(prob, 51), real(ap3), real(ap2), real(ap1), real(ap0)
*	    write(prob, 51), aimag(ap3),aimag(ap2),aimag(ap1),aimag(ap0)
	  else
*	    write(prob, *), 'ok'
	  endif

	else
	  write(prob, 51), real(a3), real(a2), real(a1), real(a0)
*	  write(prob, *), 
	endif

	goto 55

205	continue

	return
	end






	real function Mag(x)
	complex x

        Mag=(real(x)**2+aimag(x)**2)**0.5
        return
        end

